package com.platform.controller;

import com.platform.annotation.CanUserUpdateRecord;
import com.platform.entity.CommentEntity;
import com.platform.entity.Result;
import com.platform.service.CommentService;
import com.platform.utils.PageUtils;
import com.platform.utils.Query;

import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

/**
 * Controller
 *
 * @author lipengjun
 * @email 939961241@qq.com
 * @date 2017-08-28 17:03:40
 */
@RestController
@RequestMapping("comment")
public class CommentController {
    @Autowired
    private CommentService commentService;

    /**
     * 查看列表
     */
    @RequestMapping("/list")
    public Result list(@RequestBody Map<String, Object> params) {
        //查询列表数据
        Query query = new Query(params);

        List<CommentEntity> commentList = commentService.queryList(query);
        int total = commentService.queryTotal(query);

        PageUtils pageUtil = new PageUtils(commentList, total, query.getLimit(), query.getPage());

        return Result.success( pageUtil);
    }

    /**
     * 查看信息
     */
    @RequestMapping("/info/{id}")
    public Result info(@PathVariable("id") Integer id) {
        CommentEntity comment = commentService.queryObject(id);

        return Result.success( comment);
    }

    /**
     * 保存
     */
    @CanUserUpdateRecord
    @RequestMapping("/save")
    public Result save(@RequestBody CommentEntity comment) {
        commentService.save(comment);

        return Result.success();
    }

    /**
     * 修改
     */
    @CanUserUpdateRecord
    @RequestMapping("/update")
    public Result update(@RequestBody CommentEntity comment) {
        commentService.update(comment);

        return Result.success();
    }

    /**
     * 删除
     */
    @CanUserUpdateRecord
    @RequestMapping("/delete")
    public Result delete(@RequestBody Integer[] ids) {
        commentService.deleteBatch(ids);

        return Result.success();
    }

    /**
     * 查看所有列表
     */
    @RequestMapping("/queryAll")
    public Result queryAll(@RequestBody Map<String, Object> params) {

        List<CommentEntity> list = commentService.queryList(params);

        return Result.success( list);
    }

    /**
     * 修改状态
     */
    @CanUserUpdateRecord
    @RequestMapping("/toggleStatus")
    public Result toggleStatus(@RequestBody CommentEntity comment) {
        commentService.toggleStatus(comment);

        return Result.success();
    }

    /**
     * 总计
     */
    @RequestMapping("/queryTotal")
    public Result queryTotal(@RequestBody Map<String, Object> params) {
        int sum = commentService.queryTotal(params);

        return Result.success(sum);
    }
}
